#include "system.h"
#include "AT91SAM7S256.h"

AT91PS_PMC pPMC   = AT91C_BASE_PMC;

void Delay_s (unsigned long a) { while (--a!=0); }

//MAIN POINTER
AT91PS_PIO    p_pPio   = AT91C_BASE_PIOA;
AT91PS_PMC    p_pPMC   = AT91C_BASE_PMC;
AT91PS_USART  p_pUSART = AT91C_BASE_US0;
AT91PS_PDC    p_pPDC   = AT91C_BASE_PDC_US0;
AT91PS_MC     p_pMC    = AT91C_BASE_MC;
AT91PS_AIC    p_pAic   = AT91C_BASE_AIC;
AT91PS_SYS    p_pSys   = AT91C_BASE_SYS;

void InitFrec(void)
{
  /****************************************************************************
  //Set Flash Waite sate
  //Single Cycle Access at Up to 30 MHz, or 40
  //if MCK = 47923200 I have 50 Cycle for 1 usecond ( flied MC_FMR->FMCN
  AT91C_BASE_MC->MC_FMR = ((AT91C_MC_FMCN)&(48 <<16)) | AT91C_MC_FWS_1FWS ;

  //Watchdog Disable
  AT91C_BASE_WDTC->WDTC_WDMR= AT91C_WDTC_WDDIS;

  //Set MCK at 47 923 200
  //1 Enabling the Main Oscillator:
      // SCK = 1/32768 = 30.51 uSecond
      // Start up time = 8 * 6 / SCK = 56 * 30.51 = 1,46484375 ms
      pPMC->PMC_MOR = (( AT91C_CKGR_OSCOUNT & (0x06 <<8) | AT91C_CKGR_MOSCEN ));
  //Wait the startup time
    while(!(pPMC->PMC_SR & AT91C_PMC_MOSCS));

  //2 Checking the Main Oscillator Frequency (Optional)
  //3 Setting PLL and divider:
      // - div by 5 Fin = 3,6864 =(18,432 / 5)
      // - Mul 25+1: Fout =	95,8464 =(3,6864 *26)
      // for 96 MHz the erroe is 0.16%
      // Field out NOT USED = 0
      // PLLCOUNT pll startup time estimate at : 0.844 ms
      // PLLCOUNT 28 = 0.000844 /(1/32768)
       //pPMC->PMC_PLLR = ((AT91C_CKGR_DIV & 0x05) | (AT91C_CKGR_PLLCOUNT & (28<<8)) | (AT91C_CKGR_MUL & (25<<16)));
       pPMC->PMC_PLLR = ((AT91C_CKGR_DIV & 0x05) | (AT91C_CKGR_PLLCOUNT & (28<<8)) | (AT91C_CKGR_MUL & (30<<16)));

      // Wait the startup time
      while(!(pPMC->PMC_SR & AT91C_PMC_LOCK));
      while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

  //4. Selection of Master Clock and Processor Clock
  //select the PLL clock divided by 2
      pPMC->PMC_MCKR =  AT91C_PMC_PRES_CLK_2 ;
      while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

      pPMC->PMC_MCKR |= AT91C_PMC_CSS_PLL_CLK  ;
      while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

  ///////////////
  ****************************************************************************************/

/*
  //Enabling the Main Oscillator:
  pPMC->PMC_MOR = 0x00000701;
  //Wait the startup time
  while(!(pPMC->PMC_SR & AT91C_PMC_MOSCS));

  //Setting PLL and divider: (turn off any devider and multiplier)
  //pPMC->PMC_PLLR = 0x0;

  //Setting PLL and divider: (multiplier == 2)
  pPMC->PMC_PLLR = (2<<16);
  // Wait the startup time
  //while(!(pPMC->PMC_SR & AT91C_PMC_LOCK));
  while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
*/

  AT91C_BASE_WDTC->WDTC_WDMR= AT91C_WDTC_WDDIS;

  //Enabling the Main Oscillator:
  //SCK = 1/32768 = 30.51 uSecond
  //Start up time = 8 * 6 / SCK = 56 * 30.51 = 1,46484375 ms
  pPMC->PMC_MOR = (( AT91C_CKGR_OSCOUNT & (0x06 <<8) | AT91C_CKGR_MOSCEN ));
  //Wait the startup time
  while(!(pPMC->PMC_SR & AT91C_PMC_MOSCS));


  //Setting PLL and divider:
  //- div by 5 Fin = 3,6864 =(18,432 / 5)
  //- Mul 25+1: Fout =	95,8464 =(3,6864 *26)
  //for 96 MHz the erroe is 0.16%
  //Field out NOT USED = 0
  //PLLCOUNT pll startup time estimate at : 0.844 ms
  //PLLCOUNT 28 = 0.000844 /(1/32768)
  //pPMC->PMC_PLLR = ((AT91C_CKGR_DIV & 3) | (AT91C_CKGR_PLLCOUNT & (28<<8)) | (AT91C_CKGR_MUL & (24<<16)));
  pPMC->PMC_PLLR = ((AT91C_CKGR_DIV & 0x05) | (AT91C_CKGR_PLLCOUNT & (28<<8)) | (AT91C_CKGR_MUL & (26<<16)));
  //pPMC->PMC_PLLR = ((AT91C_CKGR_PLLCOUNT & (28<<8)) | (AT91C_CKGR_MUL & (30<<16)));

  // Wait the startup time
  while(!(pPMC->PMC_SR & AT91C_PMC_LOCK));
  while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

  //Selection of Master Clock and Processor Clock
  //select the PLL clock divided by 2
  pPMC->PMC_MCKR = AT91C_PMC_CSS_PLL_CLK | AT91C_PMC_PRES_CLK_2 ;
  while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

  //pPMC->PMC_MCKR |= AT91C_PMC_CSS_PLL_CLK  ;
  //while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));

  //pPMC->PMC_MCKR |= AT91C_PMC_CSS_MAIN_CLK  ;
  //while(!(pPMC->PMC_SR & AT91C_PMC_MCKRDY));
}


void InitPeriphery(void) {

  p_pPio->PIO_ODR = 0xffffffff;     // Configure all ports as Input
  p_pPio->PIO_PER = 0xffffffff;     // Enable all ports
  p_pSys->PIOA_PPUDR = 0xffffffff;  // Disable Pull-up resistor

  /**** LED BUTTONS ****/
  //enable the clock of the PIO
  p_pPMC->PMC_PCER = 1 << AT91C_ID_PIOA;

  //LED 1
  //configure the PIO Lines corresponding to LED1
  p_pPio->PIO_PER |= BIT7;  // Enable PA17
  p_pPio->PIO_SODR|= BIT7;  // Set to high
  p_pPio->PIO_OER |= BIT7;  // Configure in Output

  //RELAY
  p_pPio->PIO_PER |= BIT8; //Enable PA8
  p_pPio->PIO_CODR|= BIT8; //Low
  p_pPio->PIO_OER |= BIT8; //Configure in Output

  //BUZER
  p_pPio->PIO_PER |= BIT26; //Enable PA26
  p_pPio->PIO_CODR|= BIT26; //Low
  p_pPio->PIO_OER |= BIT26; //Configure in Output

  //BUTTON 1
  p_pPio->PIO_ODR |= BIT27; //Configure in Input
  p_pPio->PIO_PER |= BIT27; //Enable PA27

  //BUTTON 2
  p_pPio->PIO_ODR |= BIT28; //Configure in Input
  p_pPio->PIO_PER |= BIT28; //Enable PA28

  //BUTTON 3
  p_pPio->PIO_ODR |= BIT29; //Configure in Input
  p_pPio->PIO_PER |= BIT29; //Enable PA29

  //BUTTON 4
  p_pPio->PIO_ODR |= BIT30; //Configure in Input
  p_pPio->PIO_PER |= BIT30; //Enable PA30

  //BUTTON 5
  p_pPio->PIO_ODR |= BIT31; //Configure in Input
  p_pPio->PIO_PER |= BIT31; //Enable PA31

}

